import string

class References:
    
    def Desc(self):
	res=string.split(self.description,'referential integrity ')[1]
	return res

    def isForeignKey(self):
        res=1
	if string.find(self.description,'FOREIGN') == -1:
	    res=0
	return res

    def SourceTable(self):
	res=''
	if self.isForeignKey==1:
            res= string.split(self.arguments,'\\000')[1]
	else:
            res= string.split(self.arguments,'\\000')[2]	     	    
	return res
	
    def DestTable(self):
	res=''
	if self.isForeignKey==1:
            res= string.split(self.arguments,'\\000')[2]
	else:
            res= string.split(self.arguments,'\\000')[1]	     	    
	return res

    def SourceField(self):
	res=''
	if self.isForeignKey==1:
            res= string.split(self.arguments,'\\000')[4]
	else:
            res= string.split(self.arguments,'\\000')[5]	     	    
	return res

    def DestField(self):
	res=''
	if self.isForeignKey==1:
            res= string.split(self.arguments,'\\000')[5]
	else:
            res= string.split(self.arguments,'\\000')[4]	     	    
	return res	

    def MATCH(self):
    	return  string.split(self.arguments,'\\000')[3]
	
def getFieldRef(self,table,field):
	dbres=self.RefInt(tablename=table)
	rtable=[]
	for i in range(len(dbres)):
	    row=dbres[i]
	    if (row.SourceField() == field) and not (row.DestTable() in rtable) and (row.isForeignKey()== 0):
		rtable.append(row.DestTable())
	return rtable
	
def getTableRef(self,TopTable,top):
	dbres=self.GetFields(table=TopTable)
	rtable=[]
	for i in range(len(dbres)):
	    row=dbres[i]
	    attribut=row.attname
	    rtable.append(attribut)
	    attsubtables=getFieldRef(self,TopTable,attribut)	    	    
	    if len(attsubtables) >=1:
		sub=[]
		for j in range(len(attsubtables)):
		    sub.append(attsubtables[j])
		    ft=getTableRef(self,attsubtables[j],0)
		    sub.append(ft)
		rtable.append(sub)    
	    else:
		rtable.append(attsubtables)
	if top==1:
	    t=[]
	    t.append(TopTable)
	    t.append(rtable)
	else:
	    t=rtable    	
   	return t
	
def showFieldRef(self,table,field):
	dbres=self.RefInt(tablename=table)
	rtable=[]
	for i in range(len(dbres)):
	    row=dbres[i]
	    if (row.SourceField() == field) and not (row.DestTable() in rtable) and (row.isForeignKey()== 0):
		rtable.append(row.DestTable())
	return rtable
	
bgrow=['#ffc0c0','#c0ffc0','#c0c0ff','#ffffc0']
bgtop=['#ff0000','#00ff00','#0000ff','#ffff00']

def getTableColor(level):
	l=level
	while l >= len(bgtop):
	    l= l-len(bgtop)	    
	return bgtop[l]

def getRowColor(level):
	l=level
	while l >= len(bgrow):
	    l= l-len(bgrow)	    
	return bgrow[l]

def findTopTables(self):
	dbres=self.RefInt(tablename='')
	kandidat=[]
	nokandidat=[]
	toptable=[]
	for i in range(len(dbres)):
	    row=dbres[i]
	    if (row.isForeignKey()== 0) and not (row.basetable in kandidat):
		kandidat.append(row.basetable)
	    if (row.isForeignKey()== 1) and not (row.basetable in nokandidat):
		nokandidat.append(row.basetable)
	for j in range(len(kandidat)):
	    table=kandidat[j]
	    if (not (table in nokandidat)):
		toptable.append(table)	    
	return toptable

def showTableRef(self,TopTable):
	return showRefs(self,TopTable,0)
		
def showRefs(self,TopTable,level):
	dbres=self.GetFields(table=TopTable)
	rtable=[]
	f="<tr>" 
	for i in range(len(dbres)):
	    row=dbres[i]
	    attribut=row.attname
	    rtable.append(attribut)
	    f="%s<td bgcolor=%s valign=top>%s</td>" %(f,getRowColor(level),attribut)
	    attsubtables=getFieldRef(self,TopTable,attribut)	    	    
	    if len(attsubtables) >=1:
		sub=[]
		for j in range(len(attsubtables)):
		    rtable.append(attsubtables[j])
		    f="%s<td bgcolor=%s valign=top>%s</td>" %(f,getRowColor(level+1),showRefs(self,attsubtables[j],level+1))
	f="%s</tr>" %(f)
	if level==0:
	    t="<table border=0 cellpadding=2><tr><td bgcolor=%s colspan=%d><b>%s</b></td></tr>%s</table>" %(getTableColor(level),len(rtable),TopTable,f)

	else:
	    t="<table border=0 cellpadding=2 %s><tr><td bgcolor=%s colspan=%d><b>%s</b></td></tr>%s</table>" %('height="100%" width="100%"',getTableColor(level),len(rtable),TopTable,f)
   	return t
