CREATE TABLE title (
	titleid SERIAL NOT NULL,
	title character varying(50));
	
CREATE TABLE customer (
	customerid SERIAL NOT NULL,
	name character varying(75),
	city character varying(50),
	street character varying(75),
	phone character varying(20),
	fax character varying(20));
	
CREATE TABLE orders (
	orderid SERIAL NOT NULL,	
	customerid int4 NOT NULL REFERENCES customer (customerid) ON DELETE RESTRICT ON UPDATE CASCADE INITIALLY DEFERRED,
	what character varying(60),
	deadline date);

CREATE TABLE invoice (
	invoiceid SERIAL NOT NULL,
	orderid int4 NOT NULL CONSTRAINT fororders REFERENCES orders (orderid) MATCH FULL ON DELETE RESTRICT ON UPDATE CASCADE,
	amount float8);
